import Snackbar from '@mui/material/Snackbar';
import CloseIcon from '@mui/icons-material/Close';
import IconButton from '@mui/material/IconButton';
import MuiAlert from '@mui/material/Alert';

import * as React from "react";
const Alert = React.forwardRef(function Alert(props, ref) {
    return <MuiAlert elevation={6} ref={ref} variant="filled" {...props} />;
});

function SnackbarNotification(props) {
    const [open, setOpen] = React.useState(false);
    const [message, setMessage] = React.useState(false);
    const [type, setType] = React.useState(false);
    const handleToClose = (event, reason) => {
        if ("clickaway" == reason) return;
        setOpen(false);
    };

    const showNotification = (notification) => {
        setMessage(notification.message);
        setType(notification.type);
        setOpen(true);
    };

    React.useEffect(() => {
        if (props.onRender && props.onRender.open == true) {
            showNotification(props.onRender)
        }
    }, [props.onRender])

    return (
        <div>
            <Snackbar
                open={open}
                onClose={handleToClose}
                autoHideDuration={200000}
            >
                <Alert onClose={handleToClose} severity={type} sx={{ width: '100%' }}>

                    {typeof message == "string"
                        ? message
                        :
                        Object.keys(message).map(function (key) {
                            return <p key={key}>{key}:{message[key].join(", ")}</p>
                        })
                    }
                </Alert>
            </Snackbar>
        </div>
    );
}
export default SnackbarNotification;