import * as React from "react";
// import ReactDOM from "react-dom";
import { createRoot } from "react-dom/client";
import { AppMainStyle } from "./theme/AppMainStyle";
import theme from "./theme/theme";
import WorkFlowList from "./pages/WorkFlow/WorkFlowList";
import { CssBaseline, ThemeProvider } from "@mui/material";
import WorkFlow from "./pages/WorkFlow/WorkFlow";
import { LicenseInfo } from '@mui/x-data-grid-pro';

export default class HelperLibrary {
  constructor(sdk_config_file, userId, client) {
    this.sdk_config_file = sdk_config_file;
    this.userId = userId;
    this.client = client;
    this.childRef = React.createRef();
  }

  showNotification(obj) {
    this.childRef.current.showNotification(obj)
  }


  draw(props, htmlElementId = null) {
    const componentEle = (
      <ThemeProvider theme={theme}>
        <div>
          <CssBaseline>
            {AppMainStyle}
            <WorkFlow {...props} client={this.client} userId={this.userId} ref={this.childRef} NewData={this.sdk_config_file} />
          </CssBaseline>
        </div>
      </ThemeProvider>
    );
    let element = document.getElementById(`${htmlElementId}`);
    if (htmlElementId) {
      if (element) {
        return createRoot(element).render(componentEle);
      }
    }
    return componentEle;
  }
  drawList(props, htmlElementId = null) {
    LicenseInfo.setLicenseKey('b1a40bf0e39bf97b5fed8e32f6cc08d4T1JERVI6Mzk0MDYsRVhQSVJZPTE2Nzg1Mjg1NDEwMDAsS0VZVkVSU0lPTj0x');
    const componentEle = (
      <ThemeProvider theme={theme}>
        <div>
          <CssBaseline>
            {AppMainStyle}
            <WorkFlowList {...props} NewData={this.sdk_config_file} />
          </CssBaseline>
        </div>
      </ThemeProvider>
    );
    let element = document.getElementById(`${htmlElementId}`);
    if (htmlElementId) {
      if (element) {
        return createRoot(document.getElementById(`${htmlElementId}`)).render(
          componentEle
        );
      }
    }
    return componentEle;
  }
}